﻿Public Class FUnCalendario

    ' Los nombres completos de los dikas no estan util aqui
    Dim Dias() As String = {"Lunes", "Martes", "Miéricoles", "Jueves", "Viernes", "Sabado", "Domingo"}
    ' Fecha de referencia para comenzar cada mese al Lunes
    Dim FechaReferencia As Integer = 20000103 ' El 03/01/2000 es Lunes. Fecha devuelta por comparación
    ' Declaración Friend porque tiene que accedo donde UserControlMese
    Friend Meses() As String = {"Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"}
    Friend CortoNombreDias() As String = {"Lu", "Ma", "Mi", "Ju", "Vi", "Sa", "Do"}
    Friend IndiceMese As Integer

    Friend IndicePrimerDia As Integer
    Friend UlmitoDias As Integer

    Dim FechMin As Integer = 1583 ' Fecha sin problema con el Papa Gregorio XIII 
    Dim FechMax As Integer = 3210 ' solo para limitar 
    Dim UnMese As UserControl


    ' *************** Codigos para calcular sobre las fechas (solo los que necesarios aqui) *************
    Private Function EsBisiesto(ByVal SigloAno As Integer) As Byte ' 0 = No Bisiesto, 1 = Bisiesto
        Dim SS As Integer ' Siglo
        Dim AA As Integer ' Ano
        SS = SigloAno \ 100
        AA = SigloAno - SS * 100
        If ((AA > 0 And AA Mod 4 = 0) Or (AA = 0 And SS Mod 4 = 0)) Then
            Return 1
        End If
        Return 0
    End Function

    Private Function NumeroDiasHastaFinesMese(ByVal SigloAno As Integer, ByVal Mese As Integer) As Integer
        Select Case Mese
            Case 1, 3, 5, 7, 8, 10, 12
                Return 31
            Case 2
                Return (28 + EsBisiesto(SigloAno))
            Case Else
                Return 30
        End Select
    End Function

    Private Function ACuantos(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer ' Siglo con Ano
        Dim MM As Integer ' Mese
        Dim DD As Integer ' Dia
        Dim DDD As Integer ' A cuantos
        SSAA = FechaDevuelta / 10000
        MM = FechaDevuelta / 100 - SSAA * 100
        DD = FechaDevuelta - (SSAA * 10000 + MM * 100)
        DDD = DD
        For i As Integer = 1 To MM - 1
            DDD = DDD + NumeroDiasHastaFinesMese(SSAA, i)
        Next i
        Return DDD
    End Function

    Private Function NumeroDiasHastaFinesAno(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer
        Dim FechaFines As Integer
        SSAA = FechaDevuelta \ 10000
        FechaFines = SSAA * 10000 + 1231
        Return ACuantos(FechaFines) - ACuantos(FechaDevuelta)
    End Function

    Private Function NumeroDiasDesdeInicioAno(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer
        Dim FechaInicia As Integer
        SSAA = FechaDevuelta \ 10000
        FechaInicia = SSAA * 10000 + 101
        Return ACuantos(FechaDevuelta) - ACuantos(FechaInicia)
    End Function

    Private Function NumeroDiasEntreFechas(ByVal FechaDevuelta1 As Integer, ByVal FechaDevuelta2 As Integer) As Integer
        Dim Tmp As Integer
        Dim SSAAInicia As Integer
        Dim SSAAFines As Integer
        Dim NumeroDias As Integer
        If FechaDevuelta1 > FechaDevuelta2 Then
            Tmp = FechaDevuelta1
            FechaDevuelta1 = FechaDevuelta2
            FechaDevuelta2 = Tmp
        End If
        SSAAInicia = FechaDevuelta1 \ 10000
        SSAAFines = FechaDevuelta2 \ 10000
        If SSAAInicia = SSAAFines Then
            Return ACuantos(FechaDevuelta2) - ACuantos(FechaDevuelta1)
        End If
        NumeroDias = NumeroDiasHastaFinesAno(FechaDevuelta1) + NumeroDiasDesdeInicioAno(FechaDevuelta2) + 1
        For Tmp = SSAAInicia + 1 To SSAAFines - 1
            NumeroDias = NumeroDias + 365 + EsBisiesto(Tmp)
        Next Tmp
        Return NumeroDias
    End Function

    Private Function DevolverFecha(ByVal Fecha As String) As Integer
        Dim ValorFecha As Integer
        Dim IDeb As Integer ' Indice del inicio
        Dim IFin As Integer ' Indice del fines
        ValorFecha = CType(Fecha.Substring(Fecha.Length - 4), Long) * 10000  ' AAAA0000 
        IDeb = Fecha.IndexOf("/") ' Indice del primer / ............  D o DD / M o MM / AAAA
        IFin = Fecha.LastIndexOf("/") ' Indice del ultimor / ............  D o DD / M o MM / AAAA
        ValorFecha = ValorFecha + CType(Fecha.Substring(IDeb + 1, IFin - IDeb - 1), Long) * 100 ' AAAAMM00
        ValorFecha = ValorFecha + CType(Fecha.Substring(0, IDeb), Long) ' AAAAMMD ou AAAAMMDD
        Return ValorFecha
    End Function

    Private Function IndiceDelDia(ByVal Fecha As String) As Integer ' -1 si error
        Dim X As Integer
        Dim NumeroDias As Integer
        Dim FechaActual As Integer
        Try
            Fecha = Fecha.Replace("-", "/")
            FechaActual = DevolverFecha(Fecha)
            NumeroDias = NumeroDiasEntreFechas(FechaReferencia, FechaActual)
            X = NumeroDias Mod 7
            If FechaActual < FechaReferencia Then
                If X > 0 Then
                    X = 7 - X
                End If
            End If
        Catch
            Return -1
        End Try
        Return X
    End Function

    ' *************** ************************************************ *************

    Private Sub PoderMeses()
        Dim UnMese As New UserControlMese
        Dim Intervalo As Integer = 10
        Dim NumeroMese As Integer = 12
        Dim NumeroMeseHorizontale As Integer = 4
        Dim NumeroMeseVerticale As Integer = 3

        Dim AltoMese As Integer
        Dim AnchoMese As Integer
        Dim PosicionTop As Integer
        Dim PosicionLeft As Integer

        EliminarInstancias()

        Me.PanelLosCalendarios.Controls.Clear()
        AltoMese = (Me.PanelLosCalendarios.ClientSize.Height - NumeroMeseVerticale * Intervalo) / NumeroMeseVerticale
        AnchoMese = (Me.PanelLosCalendarios.ClientSize.Width - NumeroMeseHorizontale * Intervalo) / NumeroMeseHorizontale
        PosicionTop = Me.PanelLosCalendarios.ClientRectangle.Top + Intervalo / 2
        PosicionLeft = Me.PanelLosCalendarios.ClientRectangle.Left + Intervalo / 2

        For M As Integer = 0 To NumeroMese - 1

            UnMese = New UserControlMese
            IndiceMese = M
            IndicePrimerDia = IndiceDelDia("01/" & Trim((M + 1).ToString) & "/" & TBAno.Text)
            If IndicePrimerDia < 0 Then
                Exit Sub
            End If

            UlmitoDias = NumeroDiasHastaFinesMese(CType(TBAno.Text, Integer), M + 1)

            With UnMese  ' calcular la posición de cada Mese
                .Height = AltoMese
                .Width = AnchoMese
                .Top = PosicionTop
                .Left = PosicionLeft
                PosicionLeft = PosicionLeft + AnchoMese + Intervalo / 2
                If (M + 1) Mod NumeroMeseHorizontale = 0 Then
                    PosicionLeft = Me.PanelLosCalendarios.ClientRectangle.Left + Intervalo / 2
                    PosicionTop = PosicionTop + AltoMese + Intervalo / 2
                End If

            End With

            Me.PanelLosCalendarios.Controls.Add(UnMese)
        Next
    End Sub

    Private Sub Boton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BPrimero.Click, BAnterior.Click, BSiguiente.Click, BUltimo.Click
        If TBAno.Text = String.Empty Then
            Exit Sub
        End If
        Select Case sender.name
            Case "BPrimero"
                TBAno.Text = FechMin
            Case "BAnterior"
                TBAno.Text = TBAno.Text - 1
                If TBAno.Text < FechMin Then
                    TBAno.Text = FechMin
                End If
            Case "BSiguiente"
                TBAno.Text = TBAno.Text + 1
                If TBAno.Text > FechMax Then
                    TBAno.Text = FechMax
                End If
            Case "BUltimo"
                TBAno.Text = FechMax
        End Select
        TBAno_TextChanged(Me, Nothing)
    End Sub

    Private Sub TBAno_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBAno.TextChanged
        If TBAno.Text >= FechMin And TBAno.Text <= FechMax Then
            PoderMeses()
        End If
    End Sub

    Private Sub EliminarInstancias()
        Try
            For Each UC As UserControl In Me.PanelLosCalendarios.Controls
                UC.Dispose()
            Next
        Catch
        End Try
    End Sub

    Private Sub FUnCalendario_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EliminarInstancias()
    End Sub

    Private Sub FUnCalendario_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.WindowState = FormWindowState.Maximized
    End Sub
End Class

